<?php
/*
  $Id: ot_tax.php,v 1.14 2003/02/14 05:58:35 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class ot_tax {
    var $title, $output;

    function ot_tax() {
      $this->code = 'ot_tax';
      $this->title = MODULE_ORDER_TOTAL_TAX_TITLE;
      $this->description = MODULE_ORDER_TOTAL_TAX_DESCRIPTION;
      $this->enabled = ((MODULE_ORDER_TOTAL_TAX_STATUS == 'true') ? true : false);
      $this->sort_order = MODULE_ORDER_TOTAL_TAX_SORT_ORDER;

      $this->output = array();
    }

    function process() {
      global $order, $currencies, $customer_group_id, $customer_id;


  //WARNING: This module does not consider tax_class!!! We assume everything is taxable.
  //We run SQL to get total number of taxes configured for our shipping zone
  //If we have many taxes rates configured, we will compare tax priorities.
  //If taxes have different priorities, ot_tax will apply 2nd priority tax_rate over 1rst (ex: for Quebec we have PST over GST), we assume GST has the lowest priority. 
  //If taxes have the same priorities, ot_tax still show taxes on two line but dosen't apply compounded taxes (ie: Ontario)
  //If we get only one tax result, we assume we are handling only GST or HST (same scenario)
    $exempt="3";
    
    $exempt_query_count = tep_db_query("select count(*) as cuenta from customers c where c.customers_id = '" . $customer_id . "' and customers_specific_taxes_exempt <> ''");
    $exempt_count= tep_db_fetch_array($exempt_query_count);

if (isset($exempt_count) and ($exempt_count['cuenta'] > 0) ){

    $exempt_query2 = tep_db_query("select customers_specific_taxes_exempt from customers c where c.customers_id = '" . $customer_id . "'");
    $exempt2= tep_db_fetch_array($exempt_query2);

	$tax_query_raw="select tax_rates_id, tax_priority, tax_rate, tax_description 
                    from " . TABLE_TAX_RATES . " tr left join " . TABLE_ZONES_TO_GEO_ZONES . " za on (tr.tax_zone_id = za.geo_zone_id) left join " . TABLE_GEO_ZONES . " tz on (tz.geo_zone_id = tr.tax_zone_id) 
                    where (za.zone_country_id = '" . $order->delivery['country']['id'] . "') and (za.zone_id = '" . $order->delivery['zone_id'] . "') 
                    and tax_rates_id not in (" .$exempt2['customers_specific_taxes_exempt'] . ") order by tr.tax_priority";
}else{
    $exempt_query = tep_db_query("select group_specific_taxes_exempt from customers_groups c where c.customers_group_id = '" . $customer_group_id . "'");
    $exempt= tep_db_fetch_array($exempt_query);
	$tax_query_raw="select tax_rates_id, tax_priority, tax_rate, tax_description 
                    from " . TABLE_TAX_RATES . " tr left join " . TABLE_ZONES_TO_GEO_ZONES . " za on (tr.tax_zone_id = za.geo_zone_id) left join " . TABLE_GEO_ZONES . " tz on (tz.geo_zone_id = tr.tax_zone_id) 
                    where (za.zone_country_id = '" . $order->delivery['country']['id'] . "') and (za.zone_id = '" . $order->delivery['zone_id'] . "') 
                    and tax_rates_id not in (" .$exempt['group_specific_taxes_exempt'] . ")
                    order by tr.tax_priority";
}
   
   
	$subtotal = $order->info['subtotal']  ;			
	$tax_query = tep_db_query($tax_query_raw);
	      $acumulado=0;
				while ($tax = tep_db_fetch_array($tax_query)) {
				$subtotal = $order->info['subtotal']  ;
				$hst_total = $subtotal * ($tax['tax_rate'] / 100);
				
					reset($order->info['tax_groups']);
					while (list($key, $value) = each($order->info['tax_groups'])) {
						$aplicado= explode('+', $key);
						
						if (($value > 0)
						    and ( trim($tax['tax_description'])== trim($aplicado[0])
						  or trim($tax['tax_description'])== trim($aplicado[1]))
						    )
						{   
					 	  $acumulado +=  $hst_total;
						  $this->output[] = array('title' => $tax['tax_description'].': ' ,
												'text' => $currencies->format(
												$hst_total, true, $order->info['currency'], $order->info['currency_value']),
												'value' => $hst_total);
									
						} 
					}
				}


		/*Inclusin de Datos de Transporte */
		

						//We calculate $order->info with updated tax values. For this to work ot_tax has to be last ot module called, just before ot_total
	    
		$order->info['tax'] = tep_round($acumulado,$currencies->currencies[DEFAULT_CURRENCY]['decimal_places']);	
        $order->info['total'] = $subtotal + $order->info['tax'] ;	
	
	}

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_TAX_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }

      return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_TAX_STATUS', 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display Tax', 'MODULE_ORDER_TOTAL_TAX_STATUS', 'true', 'Do you want to display the order tax value?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER', '3', 'Sort order of display.', '6', '2', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
